<script setup lang="ts">
import { useAuthStore } from '@/stores/auth'
import PrintDialog from './PrintDialog.vue'
import ImportItemDialog from './ImportItemDialog.vue'
import { onMounted, ref, watchEffect } from 'vue'
import ImportPrintDialog from './ImportPrintDialog.vue'

import { useStockStore } from '@/stores/stock'
const stockStore = useStockStore()
const authStore = useAuthStore()

const currentDate = ref()
const currentTime = ref()
const now = new Date()
const time = new Date().toLocaleTimeString()
const headers = [
  {
    key: 'id',
    sortable: false,
    title: 'ProuductId'
  },
  { key: 'name', title: 'ProuductName', sortable: false },
  { key: 'minimum', title: 'Minimum', sortable: false },
  { key: 'balance', title: 'Balance', sortable: false },
  { key: 'unit', title: 'Unit', sortable: false }
]

const setupDateAndTime = () => {
  currentDate.value = `${now.getDate()}/${now.getMonth() + 1}/${now.getFullYear()}`
  currentTime.value = `${time}:${now.getMinutes()}`
}

onMounted(() => {
  setupDateAndTime()
})
const blc = ref()
function changeBl() {
  const paInt = (blc.value = parseInt(blc.value, 10))
  let bl = (stockStore.editedSProduct.balance = paInt)
  stockStore.editedSProduct.balance = bl
  clearTxtField()
}
const notifications = ref(false)
const sound = ref(false)
const widgets = ref(false)
function clearTxtField() {
  blc.value = 0
}
function validateNumber(value: any) {
  const isValid = /^\d+$/.test(value)
  return isValid || 'Please enter a number'
}
function save() {
  stockStore.logStupid
}
function openPrintDialog(){
  stockStore.dialogImport = !stockStore.dialogImport
  stockStore.dialogImportPrint = !stockStore.dialogImportPrint
}
onMounted(() => {
  stockStore.getStocks()
  stockStore.minimumStock()
})
</script>
<template>
  <v-dialog
    v-model="stockStore.dialogImport"
    fullscreen
    :scrim="false"
    transition="dialog-bottom-transition"
  >
    <v-card>
      <v-toolbar style="background-color: #403c3c; color: white;">
        <v-btn icon dark @click="stockStore.dialogImport = !stockStore.dialogImport">
          <v-icon>mdi-close</v-icon>
        </v-btn>
        <v-toolbar-title>Low Stock</v-toolbar-title>
        <v-spacer></v-spacer>
      </v-toolbar>

      <v-container>
        <v-row>
          <v-sheet width="1300" height="120">
            <div>ผู้ตรวจนับ:{{ authStore.getCurrentUser()?.fullName}}</div>
            <div>วันที่:{{ currentDate }} เวลา {{ currentTime }}</div>
          </v-sheet>
        </v-row>
        <v-row no-gutters>
          <v-sheet width="1250" height="700" class="overflow-auto">
            <div style="font-size: 20pt; text-align: center">Low Stock</div>
            <v-data-table :headers="headers" :items="stockStore.stockLows"> </v-data-table>
          </v-sheet>
          <v-row no-gutters>
            <v-col cols="6" style="padding-top: 0px">
              <div>
                <v-btn
                prepend-icon="mdi-file-import"
                  style="margin-left: 1040px; background-color: #0d47a1; color: white"
                  @click="stockStore.openImportManage"
                  >Import</v-btn
                >
              </div></v-col
            >
            <v-col cols="6" style="padding-top: 0px">
              <div>
                <v-btn
                  prepend-icon="mdi-printer-search"
                  style="margin-left: 340px"
                  @click="openPrintDialog()"
                  >Print</v-btn
                >
              </div></v-col
            >
          </v-row>
        </v-row>
      </v-container>
    </v-card>
  </v-dialog>
  <print-dialog></print-dialog>
  <import-item-dialog></import-item-dialog>
  <import-print-dialog></import-print-dialog>
</template>
<style scoped>
tbody tr:nth-of-type(even) {
  background-color: white;
}

tbody tr:nth-of-type(odd) {
  background-color: white;
}

thead {
  background-color: white;
  color: rgb(0, 0, 0);
  font-weight: bold;
}
.theme--light.v-data-table thead tr th {
  color: white;
}
.dialog-bottom-transition-enter-active,
.dialog-bottom-transition-leave-active {
  transition: transform 0.2s ease-in-out;
}
</style>
